﻿using ProjectRepairWork.Entities.Enums;
using ProjectRepairWork.Entities;
using ProjectRepairWork.Repositories;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ProjectRepairWork.Repositories.Implementation;

namespace ProjectRepairWork.Forms;

public partial class FormMaterialProcurement : Form
{
    private readonly IMaterialProcurementRepository _materialProcurementRepository;

    public FormMaterialProcurement(IMaterialProcurementRepository materialProcurementRepository, IBuildingMaterialsRepository buildingMaterialsRepository)
    {
        InitializeComponent();
        _materialProcurementRepository = materialProcurementRepository ?? throw new ArgumentNullException(nameof(materialProcurementRepository));

        comboBoxMaterialRrocurement.DataSource = buildingMaterialsRepository.ReadBuildingMaterials();
        comboBoxMaterialRrocurement.DisplayMember = "MaterialsType";
        comboBoxMaterialRrocurement.ValueMember = "Id";
    }

    private void ButtonSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (comboBoxMaterialRrocurement.SelectedIndex <0)

            {
                throw new Exception("Имеются незаполненные поля");
            }

            _materialProcurementRepository.CreateMaterialProcurement(MaterialProcurement.CreatOpertions(0,
                (int)comboBoxMaterialRrocurement.SelectedValue!, (int)numericUpDownMaterialRrocurement.Value!));

            Close();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "Ошибка при сохранении", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void ButtonCancel_Click(object sender, EventArgs e) => Close();

   
}
